<template>
  <form @submit="onSubmit">
    <div class="header-group">
      <div class="header-group__right">
        <ImageUploadField :max-size="2000000" class="thumbnail" v-model="thumbnail" id="thumbnail" title="تصویر نوشته" @input="onThumbnailChange" />
      </div>
      <div class="header-group__left">
        <TextField label="عنوان" dark v-model="title" id="post-title-field" class="field" :error="titleError"/>
        <TextField label="توضیحات کوتاه" dark v-model="shortDescription" id="post-short-description-field" class="field" :error="shortDescriptionError"/>
      </div>
    </div>
     <div class="quill-editor" 
         :content="description"
         @change="onEditorChange($event)"
         v-quill:myQuillEditor="editorOption">
    </div>
    <Button size="lg" type="contained" color="primary" class="button" :disabled="disabled" @click.native="onSubmit">{{ ButtonLabel }}</Button>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import ImageUploadField from "@/components/dashboard/ImageUploadField";


export default {
  name: "CreateCategoryForm",
  components: {
    Button,
    TextField,
    ImageUploadField
  },
  data() {
    return {
      baseUrl: process.env.baseUrl,
      oldTitle: this.post ? this.post.title : '',
      title: this.post ? this.post.title : '',
      oldShortDescription: this.post ? this.post.short_description : '',
      shortDescription: this.post ? this.post.short_description : '',
      oldDescription: this.post ? this.post.description : '',
      description: this.post ? this.post.description : '',
      thumbnail: this.post ? `${process.env.baseUrl}/${this.post.thumbnail}` : '',
      // thumbnail: this.post ? `${this.post.thumbnail}` : '',
      hasThumbnailChanged: false,
      editorOption: {
        placeholder: 'نوشته ...',
        modules: {
          toolbar: [
            ['bold', 'italic', 'underline', 'strike'],      
            ['blockquote'],
            [{ 'header': [2, 3, false] }],
          ]
        }
      }
    }
  },
  props: {
    post: {
      type: Object,
      default: null
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (this.post) {
        this.update();
      } else {
        this.create();
      }
    },
    update() {
      if (this.canUpdate) {
        this.$store.dispatch('blog/updatePost', {
          token: this.$store.getters['auth/getToken'],
          data: this.updateData,
          id: this.$route.params.id
        }).then(response => {
          console.log(response.data.data)
          if (response.status === 200) {
            this.$store.dispatch('notifications/push', {
              message: "نوشته با موفقیت بروزرسانی شد.",
              light: true,
              type: "success",
              timeout: 3000
            });
            this.$router.push('/dashboard/admin/blog');
            // this.$emit('update');
          } else {
            this.$store.dispatch('notifications/push', {
              message: "ورودی های شما نا معتبر می باشد.",
              light: true,
              type: "warning",
              timeout: 3000
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: "ورودی های خود را کنترل کنید.",
          light: true,
          type: "warning",
          timeout: 3000
        });
      }
    },
    create() {
      if (this.canCreate) {
        const data = {
          token: this.$store.getters['auth/getToken'],
          data: this.craeteData
        };
        this.$store.dispatch('blog/createPost', data).then(response => {
          if (response.status === 201) {
            this.$store.dispatch('notifications/push', {
              message: "نوشته با موفقیت اضافه شد.",
              light: true,
              type: "success",
              timeout: 3000
            });
            this.$emit('create');
          } else {
            this.$store.dispatch('notifications/push', {
              message: "ورودی های شما نا معتبر می باشد.",
              light: true,
              type: "warning",
              timeout: 3000
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: "ورودی های خود را کنترل کنید.",
          light: true,
          type: "warning",
          timeout: 3000
        });
      }
    },
    onThumbnailChange(image, change) {
      this.hasThumbnailChanged = change ? true : false;
    },
    onEditorChange({ editor, html, text }) {
      this.description = html;
    }
  },
  computed: {
    hasInfoChanged() {
      return this.title !== this.oldTitle || 
        this.shortDescription !== this.oldShortDescription ||
        this.description !== this.oldDescription ? true : false;
    },
    hasChanged() {
      return this.hasInfoChanged || this.hasThumbnailChanged ? true : false;
    },
    updateData() {
      let data = {};
      // if (this.hasThumbnailChanged) {
      //   data.thumbnail = this.thumbnail;
      // }
      data.thumbnail = this.thumbnail;
      data.title = this.title;
      data.short_description = this.shortDescription;
      data.description = this.description;
      return data;
    },
    craeteData() {
      return {
        title: this.title,
        short_description: this.shortDescription,
        description: this.description,
        thumbnail: this.thumbnail
      }
    },
    canUpdate() {
      return this.isFormValid && this.isFormFilled && this.hasChanged ? true : false;
    },
    canCreate() {
      return this.isFormFilled && this.isFormValid ? true : false;
    },
    isFormValid() {
      return this.titleError || this.shortDescriptionError ? false : true;
    },
    isFormFilled() {
      return this.title && this.shortDescription && this.description && this.thumbnail ? true : false;
    },
    disabled() {
      if (this.post) {
        return !this.canUpdate;
      } else {
        return this.isFormFilled ? false : true;
      }
    },
    titleError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.title) {
        return "";
      } else if (!regex.test(this.title)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    shortDescriptionError() {
      const regex = /^[آ-ی ء چ؟.!]+$/;
      if (!this.shortDescription) {
        return "";
      } else if (!regex.test(this.shortDescription)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    ButtonLabel() {
      return this.post ? "بروزرسانی" : "ثبت";
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.field
  margin-bottom $sm

.quill-editor
  margin-bottom $sm
  min-height 30rem
  max-height 45rem
  overflow auto

.button
  width 100%

.thumbnail 
  width 20.4rem
  height 20.4rem

.header-group
  width 100%
  display flex
  margin-bottom $sm
  &__left
    flex-grow 1
  &__right
    margin-left $sm
</style>